using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;

namespace XLToys
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("2DFC457B-552B-4524-B83C-391451BEB2E6"), ProgId("XLToys.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        private System.ComponentModel.IContainer components;

        private const int xlLinks = 0xFF;
        private const int xlColumnWidths = 8;
        private const int xlDataValidation = 6;

        private ImageList imageList16;
        private AddinExpress.MSO.ADXCommandBarButton btnTranspose;
        private AddinExpress.MSO.ADXCommandBarButton btnSkipBlanks;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteDivide;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteMultiply;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteSubtract;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteAdd;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteNone;
        private AddinExpress.MSO.ADXCommandBarPopup ppPasteSpecial;
        private AddinExpress.MSO.ADXCommandBarButton btnAll;
        private AddinExpress.MSO.ADXCommandBarButton btnAllExceptBorders;
        private AddinExpress.MSO.ADXCommandBarButton btnPasteLinks;
        private AddinExpress.MSO.ADXCommandBarButton btnFormulas_pp;
        private AddinExpress.MSO.ADXCommandBarButton btnValues;
        private AddinExpress.MSO.ADXCommandBarButton btnFormats;
        private AddinExpress.MSO.ADXCommandBarButton btnComments_pp;
        private AddinExpress.MSO.ADXCommandBarButton btnColumnWidths;
        private AddinExpress.MSO.ADXCommandBarButton btnDataValidation;
        private AddinExpress.MSO.ADXCommandBarPopup ppShowHide;
        private AddinExpress.MSO.ADXCommandBarButton btnComments;
        private AddinExpress.MSO.ADXCommandBarButton btnZeroValues;
        private AddinExpress.MSO.ADXCommandBarButton btnFormulas;
        private AddinExpress.MSO.ADXCommandBarButton btnGridlines;
        private AddinExpress.MSO.ADXCommandBarButton btnPageBreaks;
        private AddinExpress.MSO.ADXCommandBarButton btnMergeAndBottom;
        private AddinExpress.MSO.ADXCommandBarButton btnMergeAndCenter;
        private AddinExpress.MSO.ADXCommandBarButton btnMergeAndTop;
        private AddinExpress.MSO.ADXCommandBarButton btnMergeCellsTopdown;
        private AddinExpress.MSO.ADXCommandBarButton btnAlignBottom;
        private AddinExpress.MSO.ADXCommandBarButton btnAlignCenter;
        private AddinExpress.MSO.ADXCommandBarButton btnAlignTop;
        private AddinExpress.MSO.ADXCommandBarPopup ppUnderline;
        private AddinExpress.MSO.ADXCommandBarButton btnNone;
        private AddinExpress.MSO.ADXCommandBarButton btnSingle;
        private AddinExpress.MSO.ADXCommandBarButton btnDouble;
        private AddinExpress.MSO.ADXCommandBarButton btnSingleAccounting;
        private AddinExpress.MSO.ADXCommandBarButton btnDoubleAccounting;
        private AddinExpress.MSO.ADXCommandBarButton btnShrinkToFit;
        private AddinExpress.MSO.ADXCommandBarButton btnWrapText;
        private AddinExpress.MSO.ADXCommandBarButton btnAboutADXToys2;
        private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
        private ImageList ImageList32;
        private AddinExpress.MSO.ADXRibbonTab adxRibbonTab;
        private AddinExpress.MSO.ADXRibbonGroup RibbonGroup;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAbout;
        private AddinExpress.MSO.ADXRibbonSeparator RibbonSeparator1;
        private AddinExpress.MSO.ADXRibbonButtonGroup RibbonButtonGroup1;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonWrapText;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShrinkToFit;
        private AddinExpress.MSO.ADXRibbonGallery RibbonGalleryUnderline;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonNone;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonSingle;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonDouble;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonSingleAccounting;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonDoubleAccounting;
        private AddinExpress.MSO.ADXRibbonSeparator RibbonSeparator2;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAlignTop;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAlignCenter;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAlignBottom;
        private AddinExpress.MSO.ADXRibbonSeparator RibbonSeparator3;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonMergeCellsTopDown;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonMergeTop;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonMergeCenter;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonMergeBottom;
        private AddinExpress.MSO.ADXRibbonButtonGroup RibbonButtonGroup2;
        private AddinExpress.MSO.ADXRibbonGallery RibbonGalleryShowHide;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShowHideComments;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShowHideZeroValues;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShowHideFormulas;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShowHideGridlines;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonShowHidePageBreaks;
        private AddinExpress.MSO.ADXRibbonSeparator RibbonSeparator4;
        private AddinExpress.MSO.ADXRibbonMenu RibbonMenuPasteSpecial;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAll;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonAllExceptBorders;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteLinks;
        private AddinExpress.MSO.ADXRibbonMenuSeparator RibbonMenuSeparator1;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonFormulas;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonValues;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonFormats;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonComments;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonColumnWidths;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonDataValidation;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteNone;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteAdd;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteSubtract;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteMultiply;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonPasteDivide;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonSkipBlanks;
        private AddinExpress.MSO.ADXRibbonButton RibbonButtonTranspose;

        private enum XldMergeCells
        {
            mcTopDown,
            mcTop,
            mcBottom,
            mcCenter
        }

        private enum XldVAlignment
        {
            vaTop,
            vaCenter,
            vaBottom
        }

        private enum XldShowHide
        {
            shZeros,
            shComments,
            shGridlines,
            shFormulas,
            shPageBreaks
        }

        private enum XldCellFormat
        {
            cfWrapText,
            cfShrinkToFit,
            cfUnderlineNone,
            cfUnderlineSingle,
            cfUnderlineDouble,
            cfUnderlineSingleAccounting,
            cfUnderlineDoubleAccounting
        }

        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        #region Component Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.imageList16 = new System.Windows.Forms.ImageList(this.components);
            this.btnTranspose = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnSkipBlanks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteDivide = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteMultiply = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteSubtract = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteAdd = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteNone = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.ppPasteSpecial = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.btnAll = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnAllExceptBorders = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPasteLinks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnFormulas_pp = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnValues = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnFormats = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnComments_pp = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnColumnWidths = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnDataValidation = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.ppShowHide = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.btnComments = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnZeroValues = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnFormulas = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnGridlines = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnPageBreaks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnMergeAndBottom = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnMergeAndCenter = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnMergeAndTop = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnMergeCellsTopdown = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnAlignBottom = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnAlignCenter = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnAlignTop = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.ppUnderline = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
            this.btnNone = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnSingle = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnDouble = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnSingleAccounting = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnDoubleAccounting = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnShrinkToFit = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnWrapText = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.btnAboutADXToys2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
            this.ImageList32 = new System.Windows.Forms.ImageList(this.components);
            this.adxRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.RibbonGroup = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.RibbonButtonAbout = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonSeparator1 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonButtonGroup1 = new AddinExpress.MSO.ADXRibbonButtonGroup(this.components);
            this.RibbonButtonWrapText = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonShrinkToFit = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonGalleryUnderline = new AddinExpress.MSO.ADXRibbonGallery(this.components);
            this.RibbonButtonNone = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonSingle = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonDouble = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonSingleAccounting = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonDoubleAccounting = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonSeparator2 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonButtonAlignTop = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonAlignCenter = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonAlignBottom = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonSeparator3 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonButtonMergeCellsTopDown = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonMergeTop = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonMergeCenter = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonMergeBottom = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonGroup2 = new AddinExpress.MSO.ADXRibbonButtonGroup(this.components);
            this.RibbonGalleryShowHide = new AddinExpress.MSO.ADXRibbonGallery(this.components);
            this.RibbonButtonShowHideComments = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonShowHideZeroValues = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonShowHideFormulas = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonShowHideGridlines = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonShowHidePageBreaks = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonSeparator4 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonMenuPasteSpecial = new AddinExpress.MSO.ADXRibbonMenu(this.components);
            this.RibbonButtonAll = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonAllExceptBorders = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteLinks = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonMenuSeparator1 = new AddinExpress.MSO.ADXRibbonMenuSeparator(this.components);
            this.RibbonButtonFormulas = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonValues = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonFormats = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonComments = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonColumnWidths = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonDataValidation = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteNone = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteAdd = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteSubtract = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteMultiply = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonPasteDivide = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonSkipBlanks = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.RibbonButtonTranspose = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // imageList16
            // 
            this.imageList16.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList16.ImageStream")));
            this.imageList16.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList16.Images.SetKeyName(0, "");
            this.imageList16.Images.SetKeyName(1, "");
            this.imageList16.Images.SetKeyName(2, "");
            this.imageList16.Images.SetKeyName(3, "");
            this.imageList16.Images.SetKeyName(4, "");
            this.imageList16.Images.SetKeyName(5, "");
            this.imageList16.Images.SetKeyName(6, "");
            this.imageList16.Images.SetKeyName(7, "");
            this.imageList16.Images.SetKeyName(8, "");
            this.imageList16.Images.SetKeyName(9, "");
            this.imageList16.Images.SetKeyName(10, "");
            this.imageList16.Images.SetKeyName(11, "");
            this.imageList16.Images.SetKeyName(12, "");
            this.imageList16.Images.SetKeyName(13, "");
            this.imageList16.Images.SetKeyName(14, "");
            this.imageList16.Images.SetKeyName(15, "");
            this.imageList16.Images.SetKeyName(16, "");
            this.imageList16.Images.SetKeyName(17, "");
            this.imageList16.Images.SetKeyName(18, "");
            this.imageList16.Images.SetKeyName(19, "");
            this.imageList16.Images.SetKeyName(20, "");
            this.imageList16.Images.SetKeyName(21, "");
            this.imageList16.Images.SetKeyName(22, "");
            this.imageList16.Images.SetKeyName(23, "");
            this.imageList16.Images.SetKeyName(24, "");
            this.imageList16.Images.SetKeyName(25, "");
            this.imageList16.Images.SetKeyName(26, "");
            this.imageList16.Images.SetKeyName(27, "");
            this.imageList16.Images.SetKeyName(28, "");
            this.imageList16.Images.SetKeyName(29, "");
            this.imageList16.Images.SetKeyName(30, "");
            this.imageList16.Images.SetKeyName(31, "");
            // 
            // btnTranspose
            // 
            this.btnTranspose.Caption = "Transpose";
            this.btnTranspose.ControlTag = "209306a8-485e-4e62-ac5f-1470b044f671";
            this.btnTranspose.Image = 14;
            this.btnTranspose.ImageList = this.imageList16;
            this.btnTranspose.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnTranspose.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnTranspose.Tag = "77";
            this.btnTranspose.UpdateCounter = 8;
            this.btnTranspose.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnSkipBlanks
            // 
            this.btnSkipBlanks.Caption = "Skip Blanks";
            this.btnSkipBlanks.ControlTag = "ab5ed4c0-e7a6-4408-8752-40309c986a82";
            this.btnSkipBlanks.Image = 12;
            this.btnSkipBlanks.ImageList = this.imageList16;
            this.btnSkipBlanks.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnSkipBlanks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnSkipBlanks.Tag = "76";
            this.btnSkipBlanks.UpdateCounter = 8;
            this.btnSkipBlanks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteDivide
            // 
            this.btnPasteDivide.Caption = "Paste Divide";
            this.btnPasteDivide.ControlTag = "990b6bfc-5ca4-4950-9220-4fb9b3b4aa51";
            this.btnPasteDivide.Image = 9;
            this.btnPasteDivide.ImageList = this.imageList16;
            this.btnPasteDivide.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPasteDivide.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnPasteDivide.Tag = "75";
            this.btnPasteDivide.UpdateCounter = 7;
            this.btnPasteDivide.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteMultiply
            // 
            this.btnPasteMultiply.Caption = "Paste Multiply";
            this.btnPasteMultiply.ControlTag = "2fb848e6-a4aa-4de1-bd3b-c2a2e720722a";
            this.btnPasteMultiply.Image = 10;
            this.btnPasteMultiply.ImageList = this.imageList16;
            this.btnPasteMultiply.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPasteMultiply.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnPasteMultiply.Tag = "74";
            this.btnPasteMultiply.UpdateCounter = 7;
            this.btnPasteMultiply.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteSubtract
            // 
            this.btnPasteSubtract.Caption = "Paste Subtract";
            this.btnPasteSubtract.ControlTag = "891fcd06-9695-47cc-b13d-55d41462da01";
            this.btnPasteSubtract.Image = 13;
            this.btnPasteSubtract.ImageList = this.imageList16;
            this.btnPasteSubtract.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPasteSubtract.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnPasteSubtract.Tag = "73";
            this.btnPasteSubtract.UpdateCounter = 8;
            this.btnPasteSubtract.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteAdd
            // 
            this.btnPasteAdd.Caption = "Paste Add";
            this.btnPasteAdd.ControlTag = "3ed94be6-7410-495c-a39c-4ecff2149489";
            this.btnPasteAdd.Image = 8;
            this.btnPasteAdd.ImageList = this.imageList16;
            this.btnPasteAdd.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPasteAdd.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnPasteAdd.Tag = "72";
            this.btnPasteAdd.UpdateCounter = 7;
            this.btnPasteAdd.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteNone
            // 
            this.btnPasteNone.Caption = "Paste None";
            this.btnPasteNone.ControlTag = "05963d19-0ca1-42cd-bb82-dcd0079806ab";
            this.btnPasteNone.Image = 30;
            this.btnPasteNone.ImageList = this.imageList16;
            this.btnPasteNone.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPasteNone.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
            this.btnPasteNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnPasteNone.Tag = "71";
            this.btnPasteNone.UpdateCounter = 10;
            this.btnPasteNone.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // ppPasteSpecial
            // 
            this.ppPasteSpecial.BeginGroup = true;
            this.ppPasteSpecial.Caption = "Paste Special";
            this.ppPasteSpecial.Controls.Add(this.btnAll);
            this.ppPasteSpecial.Controls.Add(this.btnAllExceptBorders);
            this.ppPasteSpecial.Controls.Add(this.btnPasteLinks);
            this.ppPasteSpecial.Controls.Add(this.btnFormulas_pp);
            this.ppPasteSpecial.Controls.Add(this.btnValues);
            this.ppPasteSpecial.Controls.Add(this.btnFormats);
            this.ppPasteSpecial.Controls.Add(this.btnComments_pp);
            this.ppPasteSpecial.Controls.Add(this.btnColumnWidths);
            this.ppPasteSpecial.Controls.Add(this.btnDataValidation);
            this.ppPasteSpecial.ControlTag = "d087da95-71e0-4049-8a03-61358f12dfc0";
            this.ppPasteSpecial.UpdateCounter = 2;
            // 
            // btnAll
            // 
            this.btnAll.Caption = "All";
            this.btnAll.ControlTag = "a649ea2a-38b8-44a8-949b-1df2eca94fc0";
            this.btnAll.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnAll.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnAll.Tag = "61";
            this.btnAll.UpdateCounter = 7;
            this.btnAll.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnAllExceptBorders
            // 
            this.btnAllExceptBorders.Caption = "All except borders";
            this.btnAllExceptBorders.ControlTag = "0e549a1a-1f58-4f36-9df7-cd5bcfdddedd";
            this.btnAllExceptBorders.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnAllExceptBorders.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnAllExceptBorders.Tag = "62";
            this.btnAllExceptBorders.UpdateCounter = 5;
            this.btnAllExceptBorders.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPasteLinks
            // 
            this.btnPasteLinks.Caption = "Paste Links";
            this.btnPasteLinks.ControlTag = "dd1e2bdf-6b73-4562-ba86-59bb61e5a2e6";
            this.btnPasteLinks.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnPasteLinks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnPasteLinks.Tag = "63";
            this.btnPasteLinks.UpdateCounter = 5;
            this.btnPasteLinks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnFormulas_pp
            // 
            this.btnFormulas_pp.BeginGroup = true;
            this.btnFormulas_pp.Caption = "Formulas";
            this.btnFormulas_pp.ControlTag = "9dbae657-416d-4046-a477-1cc98f260971";
            this.btnFormulas_pp.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnFormulas_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnFormulas_pp.Tag = "64";
            this.btnFormulas_pp.UpdateCounter = 6;
            this.btnFormulas_pp.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnValues
            // 
            this.btnValues.Caption = "Values";
            this.btnValues.ControlTag = "a8aca3c1-02b1-4ae5-8af5-b092424b3fb1";
            this.btnValues.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnValues.Tag = "65";
            this.btnValues.UpdateCounter = 5;
            this.btnValues.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnFormats
            // 
            this.btnFormats.Caption = "Formats";
            this.btnFormats.ControlTag = "9e4560c6-4ff8-4e53-8bb0-817face9768f";
            this.btnFormats.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnFormats.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnFormats.Tag = "66";
            this.btnFormats.UpdateCounter = 5;
            this.btnFormats.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnComments_pp
            // 
            this.btnComments_pp.Caption = "Comments";
            this.btnComments_pp.ControlTag = "45869ace-6f9d-4b91-83e1-f50dc77fff16";
            this.btnComments_pp.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnComments_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnComments_pp.Tag = "67";
            this.btnComments_pp.UpdateCounter = 5;
            this.btnComments_pp.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnColumnWidths
            // 
            this.btnColumnWidths.Caption = "Column Widths";
            this.btnColumnWidths.ControlTag = "f80a1fa9-dd0b-4cf5-aefb-747842ab171a";
            this.btnColumnWidths.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnColumnWidths.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnColumnWidths.Tag = "68";
            this.btnColumnWidths.UpdateCounter = 5;
            this.btnColumnWidths.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnDataValidation
            // 
            this.btnDataValidation.Caption = "Data Validation";
            this.btnDataValidation.ControlTag = "eaf44d52-f3c0-412b-946d-843275a48ee7";
            this.btnDataValidation.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnDataValidation.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnDataValidation.Tag = "69";
            this.btnDataValidation.UpdateCounter = 5;
            this.btnDataValidation.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // ppShowHide
            // 
            this.ppShowHide.BeginGroup = true;
            this.ppShowHide.Caption = "Show/Hide";
            this.ppShowHide.Controls.Add(this.btnComments);
            this.ppShowHide.Controls.Add(this.btnZeroValues);
            this.ppShowHide.Controls.Add(this.btnFormulas);
            this.ppShowHide.Controls.Add(this.btnGridlines);
            this.ppShowHide.Controls.Add(this.btnPageBreaks);
            this.ppShowHide.ControlTag = "f0a81aa0-f08c-4ecf-89e3-af8ee4eef0a6";
            this.ppShowHide.UpdateCounter = 2;
            // 
            // btnComments
            // 
            this.btnComments.Caption = "Comments";
            this.btnComments.ControlTag = "edf34905-acf5-49ad-9e9c-df61f34ad3fc";
            this.btnComments.Image = 15;
            this.btnComments.ImageList = this.imageList16;
            this.btnComments.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnComments.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnComments.Tag = "41";
            this.btnComments.UpdateCounter = 10;
            this.btnComments.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnZeroValues
            // 
            this.btnZeroValues.Caption = "Zero values";
            this.btnZeroValues.ControlTag = "11d8380d-70b9-458f-8ec2-c1d67cb592d5";
            this.btnZeroValues.Image = 19;
            this.btnZeroValues.ImageList = this.imageList16;
            this.btnZeroValues.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnZeroValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnZeroValues.Tag = "42";
            this.btnZeroValues.UpdateCounter = 8;
            this.btnZeroValues.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnFormulas
            // 
            this.btnFormulas.Caption = "Formulas";
            this.btnFormulas.ControlTag = "2de4fa7b-434d-4941-8400-4dd5e51374bb";
            this.btnFormulas.Image = 16;
            this.btnFormulas.ImageList = this.imageList16;
            this.btnFormulas.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnFormulas.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnFormulas.Tag = "43";
            this.btnFormulas.UpdateCounter = 8;
            this.btnFormulas.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnGridlines
            // 
            this.btnGridlines.Caption = "Gridlines";
            this.btnGridlines.ControlTag = "5b3f4a7a-d939-47e7-9cf3-f59faf23e8a1";
            this.btnGridlines.Image = 17;
            this.btnGridlines.ImageList = this.imageList16;
            this.btnGridlines.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnGridlines.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnGridlines.Tag = "44";
            this.btnGridlines.UpdateCounter = 8;
            this.btnGridlines.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnPageBreaks
            // 
            this.btnPageBreaks.Caption = "Page breaks";
            this.btnPageBreaks.ControlTag = "18584715-62b1-4d4c-9478-235f546bf085";
            this.btnPageBreaks.Image = 18;
            this.btnPageBreaks.ImageList = this.imageList16;
            this.btnPageBreaks.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnPageBreaks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnPageBreaks.Tag = "45";
            this.btnPageBreaks.UpdateCounter = 8;
            this.btnPageBreaks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnMergeAndBottom
            // 
            this.btnMergeAndBottom.Caption = "Merge and Bottom";
            this.btnMergeAndBottom.ControlTag = "38ff9336-41d2-4fa8-8285-8c485017162a";
            this.btnMergeAndBottom.Image = 5;
            this.btnMergeAndBottom.ImageList = this.imageList16;
            this.btnMergeAndBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnMergeAndBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnMergeAndBottom.Tag = "33";
            this.btnMergeAndBottom.UpdateCounter = 7;
            this.btnMergeAndBottom.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnMergeAndCenter
            // 
            this.btnMergeAndCenter.Caption = "Merge and Center";
            this.btnMergeAndCenter.ControlTag = "bbd4bf9c-d7ba-43f6-b370-be375c65263b";
            this.btnMergeAndCenter.Image = 6;
            this.btnMergeAndCenter.ImageList = this.imageList16;
            this.btnMergeAndCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnMergeAndCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnMergeAndCenter.Tag = "32";
            this.btnMergeAndCenter.UpdateCounter = 7;
            this.btnMergeAndCenter.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnMergeAndTop
            // 
            this.btnMergeAndTop.Caption = "Merge and Top";
            this.btnMergeAndTop.ControlTag = "e0c37179-3e53-40dd-ae85-f85183e004ff";
            this.btnMergeAndTop.Image = 7;
            this.btnMergeAndTop.ImageList = this.imageList16;
            this.btnMergeAndTop.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnMergeAndTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnMergeAndTop.Tag = "31";
            this.btnMergeAndTop.UpdateCounter = 7;
            this.btnMergeAndTop.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnMergeCellsTopdown
            // 
            this.btnMergeCellsTopdown.BeginGroup = true;
            this.btnMergeCellsTopdown.Caption = "Merge Cells Top-down";
            this.btnMergeCellsTopdown.ControlTag = "301783cd-02e4-4b2c-850b-192d6ab864e5";
            this.btnMergeCellsTopdown.Image = 4;
            this.btnMergeCellsTopdown.ImageList = this.imageList16;
            this.btnMergeCellsTopdown.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnMergeCellsTopdown.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnMergeCellsTopdown.Tag = "30";
            this.btnMergeCellsTopdown.UpdateCounter = 8;
            this.btnMergeCellsTopdown.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnAlignBottom
            // 
            this.btnAlignBottom.Caption = "Align Bottom";
            this.btnAlignBottom.ControlTag = "d6a5dc02-4978-4e6b-873f-d7bb1302ba87";
            this.btnAlignBottom.Image = 1;
            this.btnAlignBottom.ImageList = this.imageList16;
            this.btnAlignBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnAlignBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnAlignBottom.Tag = "22";
            this.btnAlignBottom.UpdateCounter = 9;
            this.btnAlignBottom.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnAlignCenter
            // 
            this.btnAlignCenter.Caption = "Align Center";
            this.btnAlignCenter.ControlTag = "c95b8a71-1713-4a35-a291-81203cf3f5d9";
            this.btnAlignCenter.Image = 2;
            this.btnAlignCenter.ImageList = this.imageList16;
            this.btnAlignCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnAlignCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnAlignCenter.Tag = "21";
            this.btnAlignCenter.UpdateCounter = 7;
            this.btnAlignCenter.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnAlignTop
            // 
            this.btnAlignTop.BeginGroup = true;
            this.btnAlignTop.Caption = "Align Top";
            this.btnAlignTop.ControlTag = "1ae63fc4-8669-4d0c-90dc-07b57b7ca6c8";
            this.btnAlignTop.Image = 31;
            this.btnAlignTop.ImageList = this.imageList16;
            this.btnAlignTop.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnAlignTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnAlignTop.Tag = "20";
            this.btnAlignTop.UpdateCounter = 9;
            this.btnAlignTop.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // ppUnderline
            // 
            this.ppUnderline.Caption = "Underline";
            this.ppUnderline.Controls.Add(this.btnNone);
            this.ppUnderline.Controls.Add(this.btnSingle);
            this.ppUnderline.Controls.Add(this.btnDouble);
            this.ppUnderline.Controls.Add(this.btnSingleAccounting);
            this.ppUnderline.Controls.Add(this.btnDoubleAccounting);
            this.ppUnderline.ControlTag = "470c32c3-9de2-4ea9-9e28-efb90212ec9d";
            this.ppUnderline.DescriptionText = "Underline";
            this.ppUnderline.UpdateCounter = 5;
            // 
            // btnNone
            // 
            this.btnNone.Caption = "None";
            this.btnNone.ControlTag = "a0055817-8545-43d6-8b69-2738633419c5";
            this.btnNone.Image = 22;
            this.btnNone.ImageList = this.imageList16;
            this.btnNone.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnNone.Tag = "53";
            this.btnNone.UpdateCounter = 11;
            this.btnNone.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnSingle
            // 
            this.btnSingle.Caption = "Single";
            this.btnSingle.ControlTag = "987d5ec7-d0db-4d40-8238-a8c0d2484f89";
            this.btnSingle.Image = 23;
            this.btnSingle.ImageList = this.imageList16;
            this.btnSingle.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnSingle.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnSingle.Tag = "54";
            this.btnSingle.UpdateCounter = 12;
            this.btnSingle.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnDouble
            // 
            this.btnDouble.Caption = "Double";
            this.btnDouble.ControlTag = "bf62cd96-82c1-45e7-b9e7-f1df0b42c203";
            this.btnDouble.Image = 20;
            this.btnDouble.ImageList = this.imageList16;
            this.btnDouble.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnDouble.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnDouble.Tag = "55";
            this.btnDouble.UpdateCounter = 8;
            this.btnDouble.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnSingleAccounting
            // 
            this.btnSingleAccounting.Caption = "Single Accounting";
            this.btnSingleAccounting.ControlTag = "45e32ba5-2e05-4812-a947-a7360f7db80d";
            this.btnSingleAccounting.Image = 24;
            this.btnSingleAccounting.ImageList = this.imageList16;
            this.btnSingleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnSingleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnSingleAccounting.Tag = "56";
            this.btnSingleAccounting.UpdateCounter = 8;
            this.btnSingleAccounting.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnDoubleAccounting
            // 
            this.btnDoubleAccounting.Caption = "Double Accounting";
            this.btnDoubleAccounting.ControlTag = "50350dab-5081-4957-8c32-5df4e151ebdf";
            this.btnDoubleAccounting.Image = 21;
            this.btnDoubleAccounting.ImageList = this.imageList16;
            this.btnDoubleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnDoubleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
            this.btnDoubleAccounting.Tag = "57";
            this.btnDoubleAccounting.UpdateCounter = 10;
            this.btnDoubleAccounting.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnShrinkToFit
            // 
            this.btnShrinkToFit.Caption = "Shrink To Fit";
            this.btnShrinkToFit.ControlTag = "559a127b-644a-4ae0-9908-45dc21f55ec4";
            this.btnShrinkToFit.Image = 28;
            this.btnShrinkToFit.ImageList = this.imageList16;
            this.btnShrinkToFit.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnShrinkToFit.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnShrinkToFit.Tag = "52";
            this.btnShrinkToFit.UpdateCounter = 9;
            this.btnShrinkToFit.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnWrapText
            // 
            this.btnWrapText.BeginGroup = true;
            this.btnWrapText.Caption = "Wrap Text";
            this.btnWrapText.ControlTag = "e59cfd4d-77c5-46b1-9d24-3135c9f11c57";
            this.btnWrapText.Image = 3;
            this.btnWrapText.ImageList = this.imageList16;
            this.btnWrapText.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.btnWrapText.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnWrapText.Tag = "51";
            this.btnWrapText.UpdateCounter = 9;
            this.btnWrapText.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // btnAboutADXToys2
            // 
            this.btnAboutADXToys2.BeginGroup = true;
            this.btnAboutADXToys2.Caption = "About Add-in Express Excel Toys 2";
            this.btnAboutADXToys2.ControlTag = "f921bf69-f12c-4e28-92b0-1c4aff94401c";
            this.btnAboutADXToys2.Image = 0;
            this.btnAboutADXToys2.ImageList = this.imageList16;
            this.btnAboutADXToys2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnAboutADXToys2.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnAboutADXToys2.Tag = "10";
            this.btnAboutADXToys2.UpdateCounter = 17;
            this.btnAboutADXToys2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
            // 
            // adxCommandBar1
            // 
            this.adxCommandBar1.CommandBarName = "Add-in Express Excel Toys for .NET  (C#)";
            this.adxCommandBar1.CommandBarTag = "81a3c23d-b0e4-4e7d-ba41-fd53e9e6b070";
            this.adxCommandBar1.Controls.Add(this.btnAboutADXToys2);
            this.adxCommandBar1.Controls.Add(this.btnWrapText);
            this.adxCommandBar1.Controls.Add(this.btnShrinkToFit);
            this.adxCommandBar1.Controls.Add(this.ppUnderline);
            this.adxCommandBar1.Controls.Add(this.btnAlignTop);
            this.adxCommandBar1.Controls.Add(this.btnAlignCenter);
            this.adxCommandBar1.Controls.Add(this.btnAlignBottom);
            this.adxCommandBar1.Controls.Add(this.btnMergeCellsTopdown);
            this.adxCommandBar1.Controls.Add(this.btnMergeAndTop);
            this.adxCommandBar1.Controls.Add(this.btnMergeAndCenter);
            this.adxCommandBar1.Controls.Add(this.btnMergeAndBottom);
            this.adxCommandBar1.Controls.Add(this.ppShowHide);
            this.adxCommandBar1.Controls.Add(this.ppPasteSpecial);
            this.adxCommandBar1.Controls.Add(this.btnPasteNone);
            this.adxCommandBar1.Controls.Add(this.btnPasteAdd);
            this.adxCommandBar1.Controls.Add(this.btnPasteSubtract);
            this.adxCommandBar1.Controls.Add(this.btnPasteMultiply);
            this.adxCommandBar1.Controls.Add(this.btnPasteDivide);
            this.adxCommandBar1.Controls.Add(this.btnSkipBlanks);
            this.adxCommandBar1.Controls.Add(this.btnTranspose);
            this.adxCommandBar1.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.adxCommandBar1.UpdateCounter = 42;
            // 
            // ImageList32
            // 
            this.ImageList32.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList32.ImageStream")));
            this.ImageList32.TransparentColor = System.Drawing.Color.Transparent;
            this.ImageList32.Images.SetKeyName(0, "button32.bmp");
            // 
            // adxRibbonTab
            // 
            this.adxRibbonTab.Caption = "Add-in Express Toys for Excel (C#)";
            this.adxRibbonTab.Controls.Add(this.RibbonGroup);
            this.adxRibbonTab.Id = "adxRibbonTab_6fc5921f86b4434e921fa911c6a34ba2";
            this.adxRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonGroup
            // 
            this.RibbonGroup.Caption = "Add-in Express Toys";
            this.RibbonGroup.Controls.Add(this.RibbonButtonAbout);
            this.RibbonGroup.Controls.Add(this.RibbonSeparator1);
            this.RibbonGroup.Controls.Add(this.RibbonButtonGroup1);
            this.RibbonGroup.Controls.Add(this.RibbonButtonGroup2);
            this.RibbonGroup.Id = "adxRibbonGroup_499f6d5b1f4a4a05a98defaa6b91f4ec";
            this.RibbonGroup.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonGroup.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonAbout
            // 
            this.RibbonButtonAbout.Caption = "About";
            this.RibbonButtonAbout.Id = "adxRibbonButton_411ddf45fdbc40ec8364553f47e5c7ee";
            this.RibbonButtonAbout.Image = 0;
            this.RibbonButtonAbout.ImageList = this.ImageList32;
            this.RibbonButtonAbout.ImageTransparentColor = System.Drawing.Color.White;
            this.RibbonButtonAbout.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAbout.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.RibbonButtonAbout.Tag = 10;
            this.RibbonButtonAbout.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonSeparator1
            // 
            this.RibbonSeparator1.Id = "adxRibbonSeparator_e82b6c6a077843e8a403716435d9af28";
            this.RibbonSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonGroup1
            // 
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonWrapText);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonShrinkToFit);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonGalleryUnderline);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonSeparator2);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonAlignTop);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonAlignCenter);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonAlignBottom);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonSeparator3);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonMergeCellsTopDown);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonMergeTop);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonMergeCenter);
            this.RibbonButtonGroup1.Controls.Add(this.RibbonButtonMergeBottom);
            this.RibbonButtonGroup1.Id = "adxRibbonButtonGroup_9d6ede34cef340459747d42c968b1b9d";
            this.RibbonButtonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonWrapText
            // 
            this.RibbonButtonWrapText.Caption = "Wrap Text";
            this.RibbonButtonWrapText.Id = "adxRibbonButton_2e5f7b2c46174a46bd99c6a0c9ccf7b5";
            this.RibbonButtonWrapText.Image = 3;
            this.RibbonButtonWrapText.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonWrapText.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonWrapText.ShowCaption = false;
            this.RibbonButtonWrapText.Tag = 51;
            this.RibbonButtonWrapText.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonShrinkToFit
            // 
            this.RibbonButtonShrinkToFit.Caption = "Shrink To Fit";
            this.RibbonButtonShrinkToFit.Id = "adxRibbonButton_9910d1eba5bb4e3c935452a9b50f20c2";
            this.RibbonButtonShrinkToFit.Image = 28;
            this.RibbonButtonShrinkToFit.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShrinkToFit.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShrinkToFit.ShowCaption = false;
            this.RibbonButtonShrinkToFit.Tag = 52;
            this.RibbonButtonShrinkToFit.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonGalleryUnderline
            // 
            this.RibbonGalleryUnderline.Caption = "Underline";
            this.RibbonGalleryUnderline.Controls.Add(this.RibbonButtonNone);
            this.RibbonGalleryUnderline.Controls.Add(this.RibbonButtonSingle);
            this.RibbonGalleryUnderline.Controls.Add(this.RibbonButtonDouble);
            this.RibbonGalleryUnderline.Controls.Add(this.RibbonButtonSingleAccounting);
            this.RibbonGalleryUnderline.Controls.Add(this.RibbonButtonDoubleAccounting);
            this.RibbonGalleryUnderline.Id = "adxRibbonGallery_e93f25712a94486ba2ad2ab67767ec18";
            this.RibbonGalleryUnderline.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonGalleryUnderline.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonNone
            // 
            this.RibbonButtonNone.Caption = "None";
            this.RibbonButtonNone.Id = "adxRibbonButton_82eddd0344ac48dca9d3148208e7b7aa";
            this.RibbonButtonNone.Image = 22;
            this.RibbonButtonNone.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonNone.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonNone.Tag = 53;
            this.RibbonButtonNone.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonSingle
            // 
            this.RibbonButtonSingle.Caption = "Single";
            this.RibbonButtonSingle.Id = "adxRibbonButton_88686c84262248ddbd8ea9dda5de4b3f";
            this.RibbonButtonSingle.Image = 23;
            this.RibbonButtonSingle.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonSingle.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonSingle.Tag = 54;
            this.RibbonButtonSingle.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonDouble
            // 
            this.RibbonButtonDouble.Caption = "Double";
            this.RibbonButtonDouble.Id = "adxRibbonButton_ed3179d46ecc4007a8b743bfc8775990";
            this.RibbonButtonDouble.Image = 20;
            this.RibbonButtonDouble.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonDouble.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonDouble.Tag = 55;
            this.RibbonButtonDouble.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonSingleAccounting
            // 
            this.RibbonButtonSingleAccounting.Caption = "Single Accounting";
            this.RibbonButtonSingleAccounting.Id = "adxRibbonButton_3b4567cf30f448979ad4e2278cc40db1";
            this.RibbonButtonSingleAccounting.Image = 24;
            this.RibbonButtonSingleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonSingleAccounting.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonSingleAccounting.Tag = 56;
            this.RibbonButtonSingleAccounting.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonDoubleAccounting
            // 
            this.RibbonButtonDoubleAccounting.Caption = "Double Accounting";
            this.RibbonButtonDoubleAccounting.Id = "adxRibbonButton_585cad643cfb4b2bbb0c245f73c11f30";
            this.RibbonButtonDoubleAccounting.Image = 21;
            this.RibbonButtonDoubleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonDoubleAccounting.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonDoubleAccounting.Tag = 57;
            this.RibbonButtonDoubleAccounting.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonSeparator2
            // 
            this.RibbonSeparator2.Id = "adxRibbonSeparator_8952b6b4e49a4fce9e37a4da946bb252";
            this.RibbonSeparator2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonAlignTop
            // 
            this.RibbonButtonAlignTop.Caption = "Align Top";
            this.RibbonButtonAlignTop.Id = "adxRibbonButton_a05511b93c484d7999d469082e458ac6";
            this.RibbonButtonAlignTop.Image = 31;
            this.RibbonButtonAlignTop.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonAlignTop.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAlignTop.ShowCaption = false;
            this.RibbonButtonAlignTop.Tag = 20;
            this.RibbonButtonAlignTop.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonAlignCenter
            // 
            this.RibbonButtonAlignCenter.Caption = "Align Center";
            this.RibbonButtonAlignCenter.Id = "adxRibbonButton_3c9d566723544345aba214b782e2951c";
            this.RibbonButtonAlignCenter.Image = 2;
            this.RibbonButtonAlignCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonAlignCenter.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAlignCenter.ShowCaption = false;
            this.RibbonButtonAlignCenter.Tag = 21;
            this.RibbonButtonAlignCenter.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonAlignBottom
            // 
            this.RibbonButtonAlignBottom.Caption = "Align Bottom";
            this.RibbonButtonAlignBottom.Id = "adxRibbonButton_935bd2ea8b7c4209a8e93608eae474f4";
            this.RibbonButtonAlignBottom.Image = 1;
            this.RibbonButtonAlignBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonAlignBottom.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAlignBottom.ShowCaption = false;
            this.RibbonButtonAlignBottom.Tag = 22;
            this.RibbonButtonAlignBottom.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonSeparator3
            // 
            this.RibbonSeparator3.Id = "adxRibbonSeparator_f53f1fe0321344ee91b5013220568784";
            this.RibbonSeparator3.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonMergeCellsTopDown
            // 
            this.RibbonButtonMergeCellsTopDown.Caption = "Merge Cells Top-down";
            this.RibbonButtonMergeCellsTopDown.Id = "adxRibbonButton_ddf63845c83647d69e193348dd396143";
            this.RibbonButtonMergeCellsTopDown.Image = 4;
            this.RibbonButtonMergeCellsTopDown.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonMergeCellsTopDown.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonMergeCellsTopDown.ShowCaption = false;
            this.RibbonButtonMergeCellsTopDown.Tag = 30;
            this.RibbonButtonMergeCellsTopDown.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonMergeTop
            // 
            this.RibbonButtonMergeTop.Caption = "Merge and Top";
            this.RibbonButtonMergeTop.Id = "adxRibbonButton_255841b12e3c4579ad7ae45caaec08d5";
            this.RibbonButtonMergeTop.Image = 7;
            this.RibbonButtonMergeTop.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonMergeTop.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonMergeTop.ShowCaption = false;
            this.RibbonButtonMergeTop.Tag = 31;
            this.RibbonButtonMergeTop.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonMergeCenter
            // 
            this.RibbonButtonMergeCenter.Caption = "Merge and Center";
            this.RibbonButtonMergeCenter.Id = "adxRibbonButton_8fcf89c12d11465cb98f9413984e66a2";
            this.RibbonButtonMergeCenter.Image = 6;
            this.RibbonButtonMergeCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonMergeCenter.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonMergeCenter.ShowCaption = false;
            this.RibbonButtonMergeCenter.Tag = 32;
            this.RibbonButtonMergeCenter.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonMergeBottom
            // 
            this.RibbonButtonMergeBottom.Caption = "Merge and Bottom";
            this.RibbonButtonMergeBottom.Id = "adxRibbonButton_f5d911efb0f94809ba2b8801cf6e23f6";
            this.RibbonButtonMergeBottom.Image = 5;
            this.RibbonButtonMergeBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonMergeBottom.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonMergeBottom.ShowCaption = false;
            this.RibbonButtonMergeBottom.Tag = 33;
            this.RibbonButtonMergeBottom.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonGroup2
            // 
            this.RibbonButtonGroup2.Controls.Add(this.RibbonGalleryShowHide);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonSeparator4);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonMenuPasteSpecial);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonPasteNone);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonPasteAdd);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonPasteSubtract);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonPasteMultiply);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonPasteDivide);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonSkipBlanks);
            this.RibbonButtonGroup2.Controls.Add(this.RibbonButtonTranspose);
            this.RibbonButtonGroup2.Id = "adxRibbonButtonGroup_ab48ae38959a49518c73eaeb093b7d04";
            this.RibbonButtonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonGalleryShowHide
            // 
            this.RibbonGalleryShowHide.Caption = "Show/Hide";
            this.RibbonGalleryShowHide.Controls.Add(this.RibbonButtonShowHideComments);
            this.RibbonGalleryShowHide.Controls.Add(this.RibbonButtonShowHideZeroValues);
            this.RibbonGalleryShowHide.Controls.Add(this.RibbonButtonShowHideFormulas);
            this.RibbonGalleryShowHide.Controls.Add(this.RibbonButtonShowHideGridlines);
            this.RibbonGalleryShowHide.Controls.Add(this.RibbonButtonShowHidePageBreaks);
            this.RibbonGalleryShowHide.Id = "adxRibbonGallery_9cdd914a1d5048d28ec2f1125ccd5330";
            this.RibbonGalleryShowHide.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonGalleryShowHide.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonShowHideComments
            // 
            this.RibbonButtonShowHideComments.Caption = "Comments";
            this.RibbonButtonShowHideComments.Id = "adxRibbonButton_77f80f880b314029bef300ee30f3f484";
            this.RibbonButtonShowHideComments.Image = 15;
            this.RibbonButtonShowHideComments.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShowHideComments.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShowHideComments.Tag = 41;
            this.RibbonButtonShowHideComments.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonShowHideZeroValues
            // 
            this.RibbonButtonShowHideZeroValues.Caption = "Zero Values";
            this.RibbonButtonShowHideZeroValues.Id = "adxRibbonButton_052c81af7e8744afa31be0db0faa9c3a";
            this.RibbonButtonShowHideZeroValues.Image = 19;
            this.RibbonButtonShowHideZeroValues.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShowHideZeroValues.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShowHideZeroValues.Tag = 42;
            this.RibbonButtonShowHideZeroValues.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonShowHideFormulas
            // 
            this.RibbonButtonShowHideFormulas.Caption = "Formulas";
            this.RibbonButtonShowHideFormulas.Id = "adxRibbonButton_81e72881a9f246d2a26af55b2658b360";
            this.RibbonButtonShowHideFormulas.Image = 16;
            this.RibbonButtonShowHideFormulas.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShowHideFormulas.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShowHideFormulas.Tag = 43;
            this.RibbonButtonShowHideFormulas.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonShowHideGridlines
            // 
            this.RibbonButtonShowHideGridlines.Caption = "Gridlines";
            this.RibbonButtonShowHideGridlines.Id = "adxRibbonButton_bd24636365874b39abfa85aadff2f836";
            this.RibbonButtonShowHideGridlines.Image = 17;
            this.RibbonButtonShowHideGridlines.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShowHideGridlines.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShowHideGridlines.Tag = 44;
            this.RibbonButtonShowHideGridlines.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonShowHidePageBreaks
            // 
            this.RibbonButtonShowHidePageBreaks.Caption = "Page Breaks";
            this.RibbonButtonShowHidePageBreaks.Id = "adxRibbonButton_fd0d1906caf64c319988b513ec5fa34c";
            this.RibbonButtonShowHidePageBreaks.Image = 18;
            this.RibbonButtonShowHidePageBreaks.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonShowHidePageBreaks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonShowHidePageBreaks.Tag = 45;
            this.RibbonButtonShowHidePageBreaks.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonSeparator4
            // 
            this.RibbonSeparator4.Id = "adxRibbonSeparator_d306b97778b043009d46054a274e4fef";
            this.RibbonSeparator4.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonMenuPasteSpecial
            // 
            this.RibbonMenuPasteSpecial.Caption = "Paste Special";
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonAll);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonAllExceptBorders);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonPasteLinks);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonMenuSeparator1);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonFormulas);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonValues);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonFormats);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonComments);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonColumnWidths);
            this.RibbonMenuPasteSpecial.Controls.Add(this.RibbonButtonDataValidation);
            this.RibbonMenuPasteSpecial.Id = "adxRibbonMenu_f60d2c5703ef42a99cace4eba560669b";
            this.RibbonMenuPasteSpecial.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonMenuPasteSpecial.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonAll
            // 
            this.RibbonButtonAll.Caption = "All";
            this.RibbonButtonAll.Id = "adxRibbonButton_f0d90c0f9c704420b054075c7e8748e9";
            this.RibbonButtonAll.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonAll.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAll.Tag = 61;
            this.RibbonButtonAll.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonAllExceptBorders
            // 
            this.RibbonButtonAllExceptBorders.Caption = "All Except Borders";
            this.RibbonButtonAllExceptBorders.Id = "adxRibbonButton_302d11ea4cff46e79f89ea3303abd2ce";
            this.RibbonButtonAllExceptBorders.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonAllExceptBorders.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonAllExceptBorders.Tag = 62;
            this.RibbonButtonAllExceptBorders.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteLinks
            // 
            this.RibbonButtonPasteLinks.Caption = "Paste Links";
            this.RibbonButtonPasteLinks.Id = "adxRibbonButton_2c3565a8f334465db851309a23c7705b";
            this.RibbonButtonPasteLinks.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonPasteLinks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteLinks.Tag = 63;
            this.RibbonButtonPasteLinks.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonMenuSeparator1
            // 
            this.RibbonMenuSeparator1.Id = "adxRibbonMenuSeparator_771889e40114477387e34b34d8d9b0bf";
            this.RibbonMenuSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // RibbonButtonFormulas
            // 
            this.RibbonButtonFormulas.Caption = "Formulas";
            this.RibbonButtonFormulas.Id = "adxRibbonButton_78b9c239a0094fccae0aac4665b10fb9";
            this.RibbonButtonFormulas.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonFormulas.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonFormulas.Tag = 64;
            this.RibbonButtonFormulas.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonValues
            // 
            this.RibbonButtonValues.Caption = "Values";
            this.RibbonButtonValues.Id = "adxRibbonButton_15e63f8c9f8c476abc6766fa7776c0f5";
            this.RibbonButtonValues.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonValues.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonValues.Tag = 65;
            this.RibbonButtonValues.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonFormats
            // 
            this.RibbonButtonFormats.Caption = "Formats";
            this.RibbonButtonFormats.Id = "adxRibbonButton_799eff55a02a487d991d42dc75595519";
            this.RibbonButtonFormats.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonFormats.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonFormats.Tag = 66;
            this.RibbonButtonFormats.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonComments
            // 
            this.RibbonButtonComments.Caption = "Comments";
            this.RibbonButtonComments.Id = "adxRibbonButton_3c1bd7edd8194933bfe689df3816e982";
            this.RibbonButtonComments.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonComments.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonComments.Tag = 67;
            this.RibbonButtonComments.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonColumnWidths
            // 
            this.RibbonButtonColumnWidths.Caption = "Column Widths";
            this.RibbonButtonColumnWidths.Id = "adxRibbonButton_ddbe8d266456460d8fde6cfb38b2d4c0";
            this.RibbonButtonColumnWidths.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonColumnWidths.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonColumnWidths.Tag = 68;
            this.RibbonButtonColumnWidths.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonDataValidation
            // 
            this.RibbonButtonDataValidation.Caption = "Data Validation";
            this.RibbonButtonDataValidation.Id = "adxRibbonButton_c804172dc5014a59907376c06a95fd47";
            this.RibbonButtonDataValidation.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonButtonDataValidation.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonDataValidation.Tag = 69;
            this.RibbonButtonDataValidation.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteNone
            // 
            this.RibbonButtonPasteNone.Caption = "Paste None";
            this.RibbonButtonPasteNone.Id = "adxRibbonButton_b1b44cd1e62c40d68f14cdb45ae81119";
            this.RibbonButtonPasteNone.Image = 30;
            this.RibbonButtonPasteNone.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonPasteNone.Pressed = true;
            this.RibbonButtonPasteNone.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteNone.ShowCaption = false;
            this.RibbonButtonPasteNone.Tag = 71;
            this.RibbonButtonPasteNone.ToggleButton = true;
            this.RibbonButtonPasteNone.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteAdd
            // 
            this.RibbonButtonPasteAdd.Caption = "Paste Add";
            this.RibbonButtonPasteAdd.Id = "adxRibbonButton_4d3fe17d80f64f238d47fdf9c1de12f4";
            this.RibbonButtonPasteAdd.Image = 8;
            this.RibbonButtonPasteAdd.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonPasteAdd.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteAdd.ShowCaption = false;
            this.RibbonButtonPasteAdd.Tag = 72;
            this.RibbonButtonPasteAdd.ToggleButton = true;
            this.RibbonButtonPasteAdd.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteSubtract
            // 
            this.RibbonButtonPasteSubtract.Caption = "Paste Subtract";
            this.RibbonButtonPasteSubtract.Id = "adxRibbonButton_611a9b27ba2145cfa487c0ebb1c38990";
            this.RibbonButtonPasteSubtract.Image = 13;
            this.RibbonButtonPasteSubtract.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonPasteSubtract.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteSubtract.ShowCaption = false;
            this.RibbonButtonPasteSubtract.Tag = 73;
            this.RibbonButtonPasteSubtract.ToggleButton = true;
            this.RibbonButtonPasteSubtract.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteMultiply
            // 
            this.RibbonButtonPasteMultiply.Caption = "Paste Multiply";
            this.RibbonButtonPasteMultiply.Id = "adxRibbonButton_e6b33dd4c113407187289f351147c824";
            this.RibbonButtonPasteMultiply.Image = 10;
            this.RibbonButtonPasteMultiply.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonPasteMultiply.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteMultiply.ShowCaption = false;
            this.RibbonButtonPasteMultiply.Tag = 74;
            this.RibbonButtonPasteMultiply.ToggleButton = true;
            this.RibbonButtonPasteMultiply.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonPasteDivide
            // 
            this.RibbonButtonPasteDivide.Caption = "Paste Divide";
            this.RibbonButtonPasteDivide.Id = "adxRibbonButton_32c75946046e48dc97d1427f4011c75b";
            this.RibbonButtonPasteDivide.Image = 9;
            this.RibbonButtonPasteDivide.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonPasteDivide.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonPasteDivide.ShowCaption = false;
            this.RibbonButtonPasteDivide.Tag = 75;
            this.RibbonButtonPasteDivide.ToggleButton = true;
            this.RibbonButtonPasteDivide.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonSkipBlanks
            // 
            this.RibbonButtonSkipBlanks.Caption = "Skip Blanks";
            this.RibbonButtonSkipBlanks.Id = "adxRibbonButton_353df2dd971d49ffb9548ce0ca4da178";
            this.RibbonButtonSkipBlanks.Image = 12;
            this.RibbonButtonSkipBlanks.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonSkipBlanks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonSkipBlanks.ShowCaption = false;
            this.RibbonButtonSkipBlanks.Tag = 76;
            this.RibbonButtonSkipBlanks.ToggleButton = true;
            this.RibbonButtonSkipBlanks.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // RibbonButtonTranspose
            // 
            this.RibbonButtonTranspose.Caption = "Transpose";
            this.RibbonButtonTranspose.Id = "adxRibbonButton_c4937b71bf0c40298cab2fbe837beb34";
            this.RibbonButtonTranspose.Image = 14;
            this.RibbonButtonTranspose.ImageTransparentColor = System.Drawing.Color.Cyan;
            this.RibbonButtonTranspose.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.RibbonButtonTranspose.ShowCaption = false;
            this.RibbonButtonTranspose.Tag = 77;
            this.RibbonButtonTranspose.ToggleButton = true;
            this.RibbonButtonTranspose.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.DoRibbonButtonClick);
            // 
            // AddinModule
            // 
            this.AddinName = "Add-in Express Toys for Excel (C#)";
            this.Description = "Add-in Express Toys for Excel (C#)";
            this.Images = this.imageList16;
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
            this.OnError += new AddinExpress.MSO.ADXError_EventHandler(this.AddinModule_OnError);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            if (StartMode == AddinExpress.MSO.ADXStartMode.smFirstStart)
                DoAbout();
        }

        private void AddinModule_OnError(AddinExpress.MSO.ADXErrorEventArgs e)
        {
            e.Handled = true;
            MessageBox.Show(e.ADXError.Message, e.ADXError.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void DoClick(object sender)
        {
            switch ((sender as AddinExpress.MSO.ADXCommandBarControl).Tag)
            {
                case "10":
                    DoAbout();
                    break;
                case "51":
                    DoCellFormat(XldCellFormat.cfWrapText);
                    break;
                case "52":
                    DoCellFormat(XldCellFormat.cfShrinkToFit);
                    break;
                case "53":
                    DoCellFormat(XldCellFormat.cfUnderlineNone);
                    break;
                case "54":
                    DoCellFormat(XldCellFormat.cfUnderlineSingle);
                    break;
                case "55":
                    DoCellFormat(XldCellFormat.cfUnderlineDouble);
                    break;
                case "56":
                    DoCellFormat(XldCellFormat.cfUnderlineSingleAccounting);
                    break;
                case "57":
                    DoCellFormat(XldCellFormat.cfUnderlineDoubleAccounting);
                    break;
                case "20":
                    DoVAlign(XldVAlignment.vaTop);
                    break;
                case "21":
                    DoVAlign(XldVAlignment.vaCenter);
                    break;
                case "22":
                    DoVAlign(XldVAlignment.vaBottom);
                    break;
                case "30":
                    DoMerge(XldMergeCells.mcTopDown);
                    break;
                case "31":
                    DoMerge(XldMergeCells.mcTop);
                    break;
                case "32":
                    DoMerge(XldMergeCells.mcCenter);
                    break;
                case "33":
                    DoMerge(XldMergeCells.mcBottom);
                    break;
                case "41":
                    DoShowHide(XldShowHide.shComments);
                    break;
                case "42":
                    DoShowHide(XldShowHide.shZeros);
                    break;
                case "43":
                    DoShowHide(XldShowHide.shFormulas);
                    break;
                case "44":
                    DoShowHide(XldShowHide.shGridlines);
                    break;
                case "45":
                    DoShowHide(XldShowHide.shPageBreaks);
                    break;
                case "61":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteAll);
                    break;
                case "62":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteAllExceptBorders);
                    break;
                case "63":
                    DoPasteSpecial(xlLinks);
                    break;
                case "64":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormulas);
                    break;
                case "65":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteValues);
                    break;
                case "66":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormats);
                    break;
                case "67":
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteComments);
                    break;
                case "68":
                    DoPasteSpecial(xlColumnWidths);
                    break;
                case "69":
                    DoPasteSpecial(xlDataValidation);
                    break;
                case "71":
                case "72":
                case "73":
                case "74":
                case "75":
                    if ((sender as AddinExpress.MSO.ADXCommandBarButton).State == AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp)
                    {
                        for (int i = 13; i <= 17; i++)
                        {
                            if (i != adxCommandBar1.Controls.IndexOf(sender as AddinExpress.MSO.ADXCommandBarButton))
                            {
                                (adxCommandBar1.Controls[i] as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp;
                            }
                        }
                        (sender as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
                    }
                    break;
                case "76":
                case "77":
                    if ((sender as AddinExpress.MSO.ADXCommandBarButton).State == AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp)
                    {
                        (sender as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
                    }
                    else
                    {
                        (sender as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp;
                    }
                    break;
            }
        }

        private void DoRibbonButtonClick(object sender, AddinExpress.MSO.IRibbonControl control, bool pressed)
        {
            switch ((sender as AddinExpress.MSO.ADXRibbonButton).Tag)
            {
                // about
                case 10:
                    DoAbout();
                    break;
                // format
                case 51:
                    DoCellFormat(XldCellFormat.cfWrapText);
                    break;
                case 52:
                    DoCellFormat(XldCellFormat.cfShrinkToFit);
                    break;
                case 53:
                    DoCellFormat(XldCellFormat.cfUnderlineNone);
                    break;
                case 54:
                    DoCellFormat(XldCellFormat.cfUnderlineSingle);
                    break;
                case 55:
                    DoCellFormat(XldCellFormat.cfUnderlineDouble);
                    break;
                case 56:
                    DoCellFormat(XldCellFormat.cfUnderlineSingleAccounting);
                    break;
                case 57:
                    DoCellFormat(XldCellFormat.cfUnderlineDoubleAccounting);
                    break;
                // align
                case 20:
                    DoVAlign(XldVAlignment.vaTop);
                    break;
                case 21:
                    DoVAlign(XldVAlignment.vaCenter);
                    break;
                case 22:
                    DoVAlign(XldVAlignment.vaBottom);
                    break;
                // merge
                case 30:
                    DoMerge(XldMergeCells.mcTopDown);
                    break;
                case 31:
                    DoMerge(XldMergeCells.mcTop);
                    break;
                case 32:
                    DoMerge(XldMergeCells.mcCenter);
                    break;
                case 33:
                    DoMerge(XldMergeCells.mcBottom);
                    break;
                // show/hide
                case 41:
                    DoShowHide(XldShowHide.shComments);
                    break;
                case 42:
                    DoShowHide(XldShowHide.shZeros);
                    break;
                case 43:
                    DoShowHide(XldShowHide.shFormulas);
                    break;
                case 44:
                    DoShowHide(XldShowHide.shGridlines);
                    break;
                case 45:
                    DoShowHide(XldShowHide.shPageBreaks);
                    break;
                // paste
                case 61:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteAll);
                    break;
                case 62:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteAllExceptBorders);
                    break;
                case 63:
                    DoPasteSpecial(xlLinks);
                    break;
                case 64:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormulas);
                    break;
                case 65:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteValues);
                    break;
                case 66:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormats);
                    break;
                case 67:
                    DoPasteSpecial((int)Excel.XlPasteType.xlPasteComments);
                    break;
                case 68:
                    DoPasteSpecial(xlColumnWidths);
                    break;
                case 69:
                    DoPasteSpecial(xlDataValidation);
                    break;
                // paste options
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                    if ((sender as AddinExpress.MSO.ADXRibbonButton).Pressed)
                    {
                        for (int i = 3; i <= 7; i++)
                        {
                            if (RibbonButtonGroup2.Controls[i] != sender)
                            {
                                RibbonButtonGroup2.Controls[i].AsRibbonButton.Pressed = false;
                            }
                        }
                    }
                    else
                    {
                        RibbonButtonPasteNone.Pressed = true;
                    }
                    break;
                case 76:
                case 77:
                    break;
            }
        }

        private void DoAbout()
        {
            string toysVersion = Assembly.GetExecutingAssembly().GetName().Version.ToString(3);
            string adxVersion = Assembly.GetAssembly(typeof(AddinExpress.MSO.ADXAddinModule)).GetName().Version.ToString(3);

            AboutForm about = new AboutForm();
            about.LabelFor.Text = String.Format(about.LabelFor.Text, new Object[] { "Microsoft" + Convert.ToChar(174) + " Excel" });
            about.LabelVersion.Text = String.Format(about.LabelVersion.Text, new Object[] { toysVersion });
            about.LabelADXVersion.Text = String.Format(about.LabelADXVersion.Text, new Object[] { adxVersion });
            about.ShowDialog();
            about.Dispose();
        }

        private Excel.Range GetSelectedRange()
        {
            return ExcelApp.Selection as Excel.Range;
        }

        private void DoCellFormat(XldCellFormat format)
        {
            Excel.Range range = GetSelectedRange();
            if (range != null)
            {
                switch (format)
                {
                    case XldCellFormat.cfWrapText:
                        range.ShrinkToFit = false;
                        range.WrapText = !(bool)range.WrapText;
                        break;
                    case XldCellFormat.cfShrinkToFit:
                        range.WrapText = false;
                        range.ShrinkToFit = !(bool)range.ShrinkToFit;
                        break;
                    case XldCellFormat.cfUnderlineDouble:
                        Excel.Font font = range.Font;
                        font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDouble;
                        Marshal.ReleaseComObject(font);
                        break;
                    case XldCellFormat.cfUnderlineDoubleAccounting:
                        font = range.Font;
                        font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDoubleAccounting;
                        Marshal.ReleaseComObject(font);
                        break;
                    case XldCellFormat.cfUnderlineNone:
                        font = range.Font;
                        font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleNone;
                        Marshal.ReleaseComObject(font);
                        break;
                    case XldCellFormat.cfUnderlineSingle:
                        font = range.Font;
                        font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingle;
                        Marshal.ReleaseComObject(font);
                        break;
                    case XldCellFormat.cfUnderlineSingleAccounting:
                        range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingleAccounting;
                        break;
                }
                Marshal.ReleaseComObject(range);
            }
        }

        private void DoVAlign(XldVAlignment alignment)
        {
            Excel.Range range = GetSelectedRange();
            if (range != null)
            {
                switch (alignment)
                {
                    case XldVAlignment.vaBottom:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom;
                        break;
                    case XldVAlignment.vaCenter:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
                        break;
                    case XldVAlignment.vaTop:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop;
                        break;
                }
                Marshal.ReleaseComObject(range);
            }
        }

        private void DoMerge(XldMergeCells merge)
        {
            Excel.Range range = GetSelectedRange();
            if (range != null)
            {
                if (merge == XldMergeCells.mcTopDown)
                {
                    Excel.Areas areas = range.Areas;
                    for (int j = 1; j <= areas.Count; j++)
                    {
                        Excel.Range area = areas[j];
                        Excel.Range columns = areas[j].Columns;
                        for (int i = 1; i <= columns.Count; i++)
                        {
                            (columns[i, Type.Missing] as Excel.Range).Merge(false);
                        }
                        Marshal.ReleaseComObject(columns);
                        Marshal.ReleaseComObject(area);
                    }
                    Marshal.ReleaseComObject(areas);
                }
                else
                {
                    range.Merge(false);
                }
                switch (merge)
                {
                    case XldMergeCells.mcTop:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop;
                        break;
                    case XldMergeCells.mcBottom:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom;
                        break;
                    case XldMergeCells.mcCenter:
                        range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
                        break;
                }
                Marshal.ReleaseComObject(range);
            }
        }

        private void DoShowHide(XldShowHide sh)
        {
            Excel._Worksheet ws = null;
            Excel.Range range = GetSelectedRange();
            if (range != null)
            {
                switch (sh)
                {
                    case XldShowHide.shZeros:
                        Excel.Window wnd = ExcelApp.ActiveWindow;
                        if (wnd != null)
                        {
                            wnd.DisplayZeros = !(bool)wnd.DisplayZeros;
                            Marshal.ReleaseComObject(wnd);
                        }
                        break;
                    case XldShowHide.shComments:
                        ws = ExcelApp.ActiveSheet as Excel._Worksheet;
                        if (ws != null)
                        {
                            Excel.Comments comments = ws.Comments;
                            for (int i = 1; i <= comments.Count; i++)
                            {
                                comments[i].Visible = !comments[i].Visible;
                            }
                            Marshal.ReleaseComObject(comments);
                            Marshal.ReleaseComObject(ws);
                        }
                        break;
                    case XldShowHide.shPageBreaks:
                        ws = ExcelApp.ActiveSheet as Excel._Worksheet;
                        if (ws != null)
                        {
                            ws.DisplayAutomaticPageBreaks = !ws.DisplayAutomaticPageBreaks;
                            Marshal.ReleaseComObject(ws);
                        }
                        break;
                    case XldShowHide.shGridlines:
                        wnd = ExcelApp.ActiveWindow;
                        if (wnd != null)
                        {
                            wnd.DisplayGridlines = !wnd.DisplayGridlines;
                            Marshal.ReleaseComObject(wnd);
                        }
                        break;
                    case XldShowHide.shFormulas:
                        wnd = ExcelApp.ActiveWindow;
                        if (wnd != null)
                        {
                            wnd.DisplayFormulas = !wnd.DisplayFormulas;
                            Marshal.ReleaseComObject(wnd);
                        }
                        break;
                }
                Marshal.ReleaseComObject(range);
            }
        }

        private AddinExpress.MSO.ADXCommandBarControl ControlByTag(string tag)
        {
            for (int i = 0; i < adxCommandBar1.Controls.Count; i++)
            {
                if (adxCommandBar1.Controls[i].Tag == tag) return adxCommandBar1.Controls[i];
            }
            return null;
        }

        private void DoPasteSpecial(int paste)
        {
            Excel.Range range = GetSelectedRange();
            if (range != null)
            {
                Excel.XlPasteSpecialOperation operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone;
                if (this.HostMajorVersion > 11) // 9 == Excel 2000, 10 == XP, 11 == 2003, 12 == 2007 (ribbon), 14 == 2010, 15 == 2013
                {
                    // ribbon controls
                    for (int i = 71; i <= 75; i++)
                    {
                        if ((this.FindRibbonControl(i) as AddinExpress.MSO.ADXRibbonButton).Pressed)
                        {
                            switch (i)
                            {
                                case 71:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone;
                                    break;
                                case 72:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationAdd;
                                    break;
                                case 73:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationSubtract;
                                    break;
                                case 74:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationMultiply;
                                    break;
                                case 75:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationDivide;
                                    break;
                            }
                            break;
                        }
                    }
                }
                else
                {
                    // command bar bontrols
                    for (int i = 71; i <= 75; i++)
                    {
                        if ((ControlByTag(i.ToString()) as AddinExpress.MSO.ADXCommandBarButton).State ==
                            AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown)
                        {
                            switch (i)
                            {
                                case 71:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone;
                                    break;
                                case 72:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationAdd;
                                    break;
                                case 73:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationSubtract;
                                    break;
                                case 74:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationMultiply;
                                    break;
                                case 75:
                                    operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationDivide;
                                    break;
                            }
                            break;
                        }
                    }
                }
                bool skipBlanks;
                bool transpose;
                if (this.HostMajorVersion > 11) // 9 == Excel 2000, 10 == XP, 11 == 2003, 12 == 2007 (ribbon), 14 == 2010, 15 == 2013
                {
                    skipBlanks = (this.FindRibbonControl(76) as AddinExpress.MSO.ADXRibbonButton).Pressed;
                    transpose = (this.FindRibbonControl(77) as AddinExpress.MSO.ADXRibbonButton).Pressed;
                }
                else
                {
                    skipBlanks = ((ControlByTag("76") as AddinExpress.MSO.ADXCommandBarButton).State == AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown);
                    transpose = ((ControlByTag("77") as AddinExpress.MSO.ADXCommandBarButton).State == AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown);
                }
                switch (paste)
                {
                    case xlLinks:
                        object objParent = range.Parent;
                        if (objParent is Excel._Worksheet)
                        {
                            (objParent as Excel._Worksheet).Paste(Type.Missing, true);
                        }
                        Marshal.ReleaseComObject(objParent);
                        break;
                    default:
                        range.PasteSpecial((Excel.XlPasteType)paste, operation, skipBlanks, transpose);
                        break;
                }
                Marshal.ReleaseComObject(range);
            }
        }
    }
}

